#!/usr/bin/env python3

from asyncio import coroutine
from pequod_agent.models.version_range import version_matches


class LBUpdater:

    @coroutine
    def get_all_pools(self):
        raise NotImplementedError

    def discover_in_load_balancer(self, service_name: str, service_version: str) -> list:
        pools = self.get_all_pools()
        return [p
                for p in pools
                if p['service_name'] == service_name and version_matches(service_version, p['service_version'])]
